## orocos-kdl-1.0.2-src.tar.bz2

=== CMakeLists.txt ===
#
# Test CMake version
#
CMAKE_MINIMUM_REQUIRED(VERSION 2.4.7)
#MARK_AS_ADVANCED( FORCE CMAKE_BACKWARDS_COMPATIBILITY )

# for CMake 2.6 corrected behaviour (see "cmake --help-policy CMP0003")
IF(COMMAND cmake_policy AND ${CMAKE_MAJOR_VERSION} EQUAL 2 AND ${CMAKE_MINOR_VERSION} GREATER 4)
  CMAKE_POLICY(SET CMP0003 NEW)
ENDIF(COMMAND cmake_policy AND ${CMAKE_MAJOR_VERSION} EQUAL 2 AND ${CMAKE_MINOR_VERSION} GREATER 4)

###################################################
#                                                 #
#       Start project customization section       #
#                                                 #
###################################################

PROJECT(Orocos-KDL)

SET( KDL_VERSION 1.0.2 CACHE STRING "Version of Orocos KDL" )
STRING( REGEX MATCHALL "[0-9]+" KDL_VERSIONS ${KDL_VERSION} )
LIST( GET KDL_VERSIONS 0 KDL_VERSION_MAJOR)
LIST( GET KDL_VERSIONS 1 KDL_VERSION_MINOR)
LIST( GET KDL_VERSIONS 2 KDL_VERSION_PATCH)

SET(KDL_VERSION_PATCH "${KDL_VERSION_PATCH}")
MESSAGE( "Orocos KDL version ${VERSION} (${KDL_VERSION_MAJOR}.${KDL_VERSION_MINOR}.${KDL_VERSION_PATCH})" )

SET( PROJ_SOURCE_DIR ${Orocos-KDL_SOURCE_DIR} )
SET( PROJ_BINARY_DIR ${Orocos-KDL_BINARY_DIR} )


IF(NOT CMAKE_INSTALL_PREFIX)
  SET( CMAKE_INSTALL_PREFIX /usr/local/ CACHE PATH "Installation directory" FORCE)
  MESSAGE( STATUS "Setting installation directory to ${CMAKE_INSTALL_PREFIX}" )
ENDIF(NOT CMAKE_INSTALL_PREFIX)

SET(CMAKE_VERSION "${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION}.${CMAKE_PATCH_VERSION}")


IF ( NOT CMAKE_BUILD_TYPE )
  SET(CMAKE_BUILD_TYPE Release CACHE STRING "Choose the type of build, options are: None(CMAKE_CXX_FLAGS or CMAKE_C_FLAGS used) Debug Release RelWithDebInfo MinSizeRel." FORCE)
  MESSAGE( "Setting build type to '${CMAKE_BUILD_TYPE}'" )
ELSE ( NOT CMAKE_BUILD_TYPE )
  MESSAGE( "Build type set to '${CMAKE_BUILD_TYPE}' by user." )
ENDIF ( NOT CMAKE_BUILD_TYPE )

SET( KDL_CFLAGS "" CACHE INTERNAL "")

INCLUDE(${PROJ_SOURCE_DIR}/config/FindEigen2.cmake)

OPTION( OROCOS_PLUGIN "Build Orocos-plugin?" OFF)
IF( OROCOS_PLUGIN )
  SET( RTT_VVERSION "v1.4.x" )
  IF(NOT OROCOS_INSTALL)
    SET( OROCOS_INSTALL /usr CACHE PATH "The RTT installation directory.")
  ENDIF(NOT OROCOS_INSTALL)
  INCLUDE (${PROJ_SOURCE_DIR}/config/FindOrocosRTT.cmake)
  IF (OROCOS_RTT_1.4)
    SET( CMAKE_C_FLAGS_RTT "-O2 -DNDEBUG ${OROCOS_RTT_DEFINES}")
    SET( CMAKE_CXX_FLAGS_RTT "-O2 -DNDEBUG ${OROCOS_RTT_DEFINES}")
    MESSAGE( "CMAKE_CXX_FLAGS_RTT are : ${CMAKE_CXX_FLAGS_RTT}" )
  ENDIF (OROCOS_RTT_1.4)
INCLUDE (${PROJ_SOURCE_DIR}/config/FindCorbaDeps.cmake)
ENDIF( OROCOS_PLUGIN )

INCLUDE (${PROJ_SOURCE_DIR}/config/DependentOption.cmake)

OPTION( PYTHON_BINDINGS "Build python-bindings?" OFF)
IF(PYTHON_BINDINGS)
INCLUDE (${PROJ_SOURCE_DIR}/config/FindSIPandPython.cmake)
ENDIF(PYTHON_BINDINGS)

OPTION(ENABLE_TESTS OFF "Enable building of tests")
IF( ENABLE_TESTS )
  # If not in standard paths, set CMAKE_xxx_PATH's in environment, eg.
  # export CMAKE_INCLUDE_PATH=/opt/local/include
  # export CMAKE_LIBRARY_PATH=/opt/local/lib
  FIND_LIBRARY(CPPUNIT cppunit)
  FIND_PATH(CPPUNIT_HEADERS cppunit/TestRunner.h)
  IF ( CPPUNIT AND CPPUNIT_HEADERS)
    MESSAGE("-- Looking for Cppunit - found")
  ELSE ( CPPUNIT AND CPPUNIT_HEADERS )
    MESSAGE( FATAL_ERROR "-- Looking for Cppunit - not found")
  ENDIF ( CPPUNIT AND CPPUNIT_HEADERS )
ENDIF(ENABLE_TESTS )

ADD_SUBDIRECTORY( doc )
ADD_SUBDIRECTORY( src )
ADD_SUBDIRECTORY( tests )
ADD_SUBDIRECTORY( models )

CONFIGURE_FILE(
  "${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in"
  "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
  IMMEDIATE @ONLY)

CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/KDLConfig.cmake.in
  ${CMAKE_CURRENT_BINARY_DIR}/orocos-kdl-config.cmake @ONLY)
INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/orocos-kdl-config.cmake DESTINATION share/orocos-kdl)

ADD_CUSTOM_TARGET(uninstall
  "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")

############################################################
##                                                         #
## Setup PACKAGING                                         #
##                                                         #
############################################################

IF ( "${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION}" STREQUAL "2.4" )
OPTION( CPACK_PACKAGES "Set to ON to build the packages. Requires cmake >2.4" OFF )
IF (CPACK_PACKAGES)

INCLUDE(InstallRequiredSystemLibraries)

# ATTENTION: There is sometimes a _SOURCE_ version of an
# option as well, set both if necessary !

# Create .tar.gz and .tar.tbz2 files:
SET(CPACK_GENERATOR "TBZ2")
SET(CPACK_SOURCE_GENERATOR "TBZ2")

# The plain 'package' target works correctly.
SET(CPACK_IGNORE_FILES        "/CVS/;/.svn/;.swp$;.#;/#;/build/")
# Since the 'package_source' target does a bold copy, define a list of
# files which should be excluded. Note that 'subpattern' matching is used,
# thus to exclude a directory use /mydir/
SET(CPACK_SOURCE_IGNORE_FILES "/CVS/;/.svn/;.swp$;.#;/#;/build/;~")

SET(CPACK_PACKAGE_DESCRIPTION_SUMMARY "Orocos KDL")
SET(CPACK_PACKAGE_VENDOR "The Orocos Community")
SET(CPACK_PACKAGE_DESCRIPTION_FILE "${CMAKE_CURRENT_SOURCE_DIR}/README")
SET(CPACK_RESOURCE_FILE_LICENSE "${CMAKE_CURRENT_SOURCE_DIR}/COPYING")
SET(CPACK_PACKAGE_VERSION_MAJOR "${KDL_VERSION_MAJOR}")
SET(CPACK_PACKAGE_VERSION_MINOR "${KDL_VERSION_MINOR}")
SET(CPACK_PACKAGE_VERSION_PATCH "${KDL_VERSION_PATCH}")
SET(CPACK_PACKAGE_INSTALL_DIRECTORY "CMAKE ${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION}")
SET(CPACK_STRIP_FILES "bin/cmake")
#SET(CPACK_PACKAGE_EXECUTABLES "OrocosExec" "Orocos Executable")
INCLUDE(CPack)
ENDIF (CPACK_PACKAGES)
ELSE ( "${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION}" STREQUAL "2.4" )

   MESSAGE ( "Disabling packaging for version ${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION}")

ENDIF ( "${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION}" STREQUAL "2.4" )

=== doc/CMakeLists.txt ===

CONFIGURE_FILE(Doxyfile.in doc/Doxyfile IMMEDIATE @ONLY)
ADD_CUSTOM_TARGET(docs "doxygen" "Doxyfile")
INSTALL(FILES ${CMAKE_CURRENT_BINARY_DIR}/kdl.tag DESTINATION share/doc/liborocos-kdl/ OPTIONAL) # only installs if found.

=== models/CMakeLists.txt ===
OPTION(BUILD_MODELS "Build models for some well known robots" FALSE)

IF(BUILD_MODELS)
  
  ADD_LIBRARY(orocos-kdl-models SHARED puma560.cpp) 
  INCLUDE_DIRECTORIES(${PROJ_SOURCE_DIR}/src)
  SET_TARGET_PROPERTIES( orocos-kdl-models PROPERTIES
    SOVERSION "${KDL_VERSION_MAJOR}.${KDL_VERSION_MINOR}"
    VERSION "${KDL_VERSION}"
    COMPILE_FLAGS "${CMAKE_CXX_FLAGS_ADD} ${KDL_CFLAGS}")
  TARGET_LINK_LIBRARIES(orocos-kdl-models orocos-kdl)
  
  INSTALL_TARGETS( /lib orocos-kdl-models)
  INSTALL_FILES( /include/kdl FILES models.hpp)
ENDIF(BUILD_MODELS)

INCLUDE(CMakeDependentOption)
CMAKE_DEPENDENT_OPTION(BUILD_MODELS_DEMO "Build demo for some of the models" OFF "BUILD_MODELS" OFF)  
IF(BUILD_MODELS_DEMO)
  ADD_EXECUTABLE(p560test puma560test.cpp)
  TARGET_LINK_LIBRARIES(p560test orocos-kdl-models)
  SET_TARGET_PROPERTIES( p560test PROPERTIES
    COMPILE_FLAGS "${CMAKE_CXX_FLAGS_ADD} ${KDL_CFLAGS}")
ENDIF(BUILD_MODELS_DEMO)

=== src/CMakeLists.txt ===
FILE( GLOB KDL_SRCS [^.]*.cpp )
FILE( GLOB KDL_HPPS [^.]*.hpp [^.]*.inl)

FILE( GLOB UTIL_SRCS utilities/[^.]*.cpp utilities/[^.]*.cxx)
FILE( GLOB UTIL_HPPS utilities/[^.]*.h utilities/[^.]*.hpp)

ADD_LIBRARY(orocos-kdl SHARED ${KDL_SRCS} ${UTIL_SRCS}) 
SET_TARGET_PROPERTIES( orocos-kdl PROPERTIES
  SOVERSION "${KDL_VERSION_MAJOR}.${KDL_VERSION_MINOR}"
  VERSION "${KDL_VERSION}"
  COMPILE_FLAGS "${CMAKE_CXX_FLAGS_ADD} ${KDL_CFLAGS}")

INSTALL_TARGETS( /lib orocos-kdl)

# CMake 2.2:
INSTALL_FILES( /include/kdl FILES ${KDL_HPPS})
INSTALL_FILES( /include/kdl/utilities FILES ${UTIL_HPPS})

# Orocos convention:
CONFIGURE_FILE( kdl.pc.in ${CMAKE_CURRENT_BINARY_DIR}/orocos-kdl.pc @ONLY)
INSTALL_FILES( /lib/pkgconfig FILES ${CMAKE_CURRENT_BINARY_DIR}/orocos-kdl.pc)

IF( OROCOS_PLUGIN )
  ADD_SUBDIRECTORY( bindings/rtt )
ENDIF( OROCOS_PLUGIN )

IF( PYTHON_BINDINGS )
  ADD_SUBDIRECTORY( bindings/python )
ENDIF( PYTHON_BINDINGS )

=== tests/CMakeLists.txt ===
IF(ENABLE_TESTS)
  ENABLE_TESTING()

  INCLUDE_DIRECTORIES(${PROJ_SOURCE_DIR}/src ${CPPUNIT_HEADERS})

  ADD_EXECUTABLE(framestest framestest.cpp test-runner.cpp)
  TARGET_LINK_LIBRARIES(framestest orocos-kdl ${CPPUNIT})
  SET(TESTNAME "framestest")
  SET_TARGET_PROPERTIES( framestest PROPERTIES
   COMPILE_FLAGS "${CMAKE_CXX_FLAGS_ADD} ${KDL_CFLAGS} -DTESTNAME=\"\\\"${TESTNAME}\\\"\" ")
  ADD_TEST(framestest framestest)
  
 ADD_EXECUTABLE(kinfamtest kinfamtest.cpp test-runner.cpp)
 TARGET_LINK_LIBRARIES(kinfamtest orocos-kdl ${CPPUNIT})
 SET(TESTNAME "kinfamtest")
 SET_TARGET_PROPERTIES( kinfamtest PROPERTIES
  COMPILE_FLAGS "${CMAKE_CXX_FLAGS_ADD} ${KDL_CFLAGS}")
 ADD_TEST(kinfamtest kinfamtest)

 ADD_EXECUTABLE(solvertest solvertest.cpp test-runner.cpp)
 TARGET_LINK_LIBRARIES(solvertest orocos-kdl ${CPPUNIT})
 SET(TESTNAME "solvertest")
 SET_TARGET_PROPERTIES( solvertest PROPERTIES
  COMPILE_FLAGS "${CMAKE_CXX_FLAGS_ADD} ${KDL_CFLAGS} -DTESTNAME=\"\\\"${TESTNAME}\\\"\" ")
 ADD_TEST(solvertest solvertest)

 ADD_EXECUTABLE(inertiatest inertiatest.cpp test-runner.cpp)
 TARGET_LINK_LIBRARIES(inertiatest orocos-kdl ${CPPUNIT})
 SET(TESTNAME "inertiatest")
 SET_TARGET_PROPERTIES( inertiatest PROPERTIES
  COMPILE_FLAGS "${CMAKE_CXX_FLAGS_ADD} ${KDL_CFLAGS} -DTESTNAME=\"\\\"${TESTNAME}\\\"\" ")
 ADD_TEST(inertiatest inertiatest)

 ADD_EXECUTABLE(jacobiantest jacobiantest.cpp test-runner.cpp)
 SET(TESTNAME "jacobiantest")
 TARGET_LINK_LIBRARIES(jacobiantest orocos-kdl ${CPPUNIT})
 SET_TARGET_PROPERTIES( jacobiantest PROPERTIES
  COMPILE_FLAGS "${CMAKE_CXX_FLAGS_ADD} ${KDL_CFLAGS} -DTESTNAME=\"\\\"${TESTNAME}\\\"\" ")
 ADD_TEST(jacobiantest jacobiantest)

#  ADD_EXECUTABLE(rframestest  rframestest.cpp)
#  TARGET_LINK_LIBRARIES(rframestest orocos-kdl)
#  ADD_TEST(rframestest rframestest)
#
#  ADD_EXECUTABLE(rallnumbertest  rallnumbertest.cpp)
#  TARGET_LINK_LIBRARIES(rallnumbertest orocos-kdl)
#  ADD_TEST(rallnumbertest rallnumbertest)
#
#  
# IF(OROCOS_PLUGIN)
#   ADD_EXECUTABLE(toolkittest toolkittest.cpp)
#   LINK_DIRECTORIES(${OROCOS_RTT_LINK_DIRS})
#   TARGET_LINK_LIBRARIES(toolkittest orocos-kdltk orocos-kdl ${OROCOS_RTT_LIBS})
#   ADD_TEST(toolkittest toolkittest)
# ENDIF(OROCOS_PLUGIN)
#
# IF(PYTHON_BINDINGS)
#   CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/framestest.py
#     ${CMAKE_CURRENT_BINARY_DIR}/framestest.py COPY_ONLY)
#   CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/kinfamtest.py
#     ${CMAKE_CURRENT_BINARY_DIR}/kinfamtest.py COPY_ONLY)
#   CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/frameveltest.py
#     ${CMAKE_CURRENT_BINARY_DIR}/frameveltest.py COPY_ONLY)
#   CONFIGURE_FILE(${CMAKE_CURRENT_SOURCE_DIR}/PyKDLtest.py
#     ${CMAKE_CURRENT_BINARY_DIR}/PyKDLtest.py COPY_ONLY)
#   ADD_TEST(PyKDLtest PyKDLtest.py)
#   
#  
# ENDIF(PYTHON_BINDINGS)
  
  ADD_CUSTOM_TARGET(check ctest -V WORKING_DIRECTORY ${PROJ_BINARY_DIR}/tests)
ENDIF(ENABLE_TESTS)

=== src/bindings/python/CMakeLists.txt ===
if(PYTHON_BINDINGS AND SIP_IS_GOOD)
include(SIPMacros)

include_directories(
  ${SIP_INCLUDE_DIR}
  ${PYTHON_INCLUDE_PATH}
  ${CMAKE_SOURCE_DIR}/src
  ${EIGEN2_INCLUDE_DIR})

file(GLOB SIP_FILES "${CMAKE_CURRENT_SOURCE_DIR}/*.sip")
set(SIP_INCLUDES ${SIP_FILES})
add_sip_python_module(PyKDL PyKDL/PyKDL.sip orocos-kdl)
#set(SIP_EXTRA_FILES_DEPEND ${SIP_FILES})
endif(PYTHON_BINDINGS AND SIP_IS_GOOD)

=== src/bindings/rtt/CMakeLists.txt ===
IF( OROCOS_PLUGIN )

  OPTION(ROTATION_PROPERTIES_RPY "" ON)
  OPTION(ROTATION_PROPERTIES_EULER "" OFF)

#  SET(ROTATION_PROPERTIES "RPY" CACHE STRING "choose how the plugin should write angles to the propertyfile: RPY, EULER, MATRIX" )
#  IF( ${ROTATION_PROPERTIES} STREQUAL "RPY" )
#    MESSAGE("Choosing RPY for Rotation property type")
#    SET(ROTATION_PROPERTIES_RPY 1)
#  ENDIF(${ROTATION_PROPERTIES} STREQUAL "RPY")
#  IF(${ROTATION_PROPERTIES} STREQUAL "EULER")
#    MESSAGE("Choosing EULER for Rotation property type")
#    SET(ROTATION_PROPERTIES_EULER 1)
#  ENDIF(${ROTATION_PROPERTIES} STREQUAL "EULER")

  CONFIGURE_FILE( kdltk.hpp.in ${CMAKE_CURRENT_BINARY_DIR}/kdltk.hpp)
  INSTALL_FILES( /include/kdl/bindings/rtt FILES ${CMAKE_CURRENT_BINARY_DIR}/kdltk.hpp)
  INCLUDE_DIRECTORIES(${PROJ_SOURCE_DIR}/src)

  FILE( GLOB SRCS [^.]*.cpp [^.]*.cxx)
  FILE( GLOB HPPS [^.]*.hpp [^.]*.h)
  
  INCLUDE_DIRECTORIES(${PROJ_SOURCE_DIR} ${PROJ_BINARY_DIR}/src/bindings/rtt
	${CMAKE_CURRENT_BINARY_DIR}/src/bindings/rtt/
      ${OROCOS_RTT_INCLUDE_DIRS} ${OROCOS_INSTALL}/include/rtt /usr/include/orbsvcs)
  ADD_DEFINITIONS(-D_REENTRANT)
  INCLUDE_DIRECTORIES(/usr/include/orbsvcs /usr/include/rtt)
  ADD_LIBRARY(orocos-kdltk-${OROCOS_TARGET} SHARED ${SRCS})
  SET_TARGET_PROPERTIES(orocos-kdltk-${OROCOS_TARGET} PROPERTIES
  SOVERSION "${KDL_VERSION_MAJOR}.${KDL_VERSION_MINOR}" 
  VERSION "${KDL_VERSION}"
  COMPILE_FLAGS "${CMAKE_CXX_FLAGS_ADD} ${KDL_CFLAGS}") 
  INSTALL_TARGETS( /lib/rtt/${OROCOS_TARGET}/plugins orocos-kdltk-${OROCOS_TARGET})
  INSTALL_FILES( /include/kdl/bindings/rtt FILES ${HPPS})
  TARGET_LINK_LIBRARIES(orocos-kdltk-${OROCOS_TARGET} orocos-kdl orocos-rtt-${OROCOS_TARGET})

  CONFIGURE_FILE( kdltk.pc.in ${CMAKE_CURRENT_BINARY_DIR}/orocos-kdltk-${OROCOS_TARGET}.pc @ONLY)
  INSTALL_FILES( /lib/pkgconfig FILES ${CMAKE_CURRENT_BINARY_DIR}/orocos-kdltk-${OROCOS_TARGET}.pc)

  add_subdirectory(corba)

ENDIF( OROCOS_PLUGIN )

=== src/bindings/rtt/corba/CMakeLists.txt ===
#INCLUDE (${PROJ_SOURCE_DIR}/config/TaoIDL.cmake)
INCLUDE (${PROJ_SOURCE_DIR}/config/DependentOption.cmake)
#INCLUDE(${PROJ_SOURCE_DIR}/config/FindCorbaDeps.cmake)

#this option was set in global_rules.cmake
IF(ENABLE_CORBA )
  MESSAGE( "CORBA Support enabled.")
  # Finally:

  INCLUDE (${PROJ_SOURCE_DIR}/config/UseCorba.cmake)
    
  # Add includes / lib paths if necessary
  IF( NOT ${ACE_DIR} STREQUAL /usr/include )
    SET(CMAKE_C_FLAGS_RTT "${CMAKE_C_FLAGS_RTT} -I${ACE_DIR}" CACHE INTERNAL "")
    SET(CMAKE_LINKFLAGS_RTT "${CMAKE_LINKFLAGS_RTT} -L${ACE_DIR}/../lib" CACHE INTERNAL "")
  ENDIF( NOT ${ACE_DIR} STREQUAL /usr/include )
  IF( NOT ${TAO_DIR} STREQUAL /usr/include )
    SET(CMAKE_C_FLAGS_RTT "${CMAKE_C_FLAGS_RTT} -I${TAO_DIR}" CACHE INTERNAL "")
  ENDIF( NOT ${TAO_DIR} STREQUAL /usr/include )
  IF( NOT ${ORBSVCS_DIR} STREQUAL /usr/include )
    SET(CMAKE_C_FLAGS_RTT "${CMAKE_C_FLAGS_RTT} -I${ORBSVCS_DIR}" CACHE INTERNAL "")
  ENDIF( NOT ${ORBSVCS_DIR} STREQUAL /usr/include )

  FILE( GLOB IDLS [^.]*.idl )
  FILE( GLOB CPPS [^.]*.cpp )
  FILE( GLOB HPPS [^.]*.hpp [^.]*.h [^.]*.inl)

  ORO_ADD_CORBA_SERVERS(CPPS HPPS ${IDLS} )
  SET( ENV{GLOBAL_GENERATED_SRCS} "${CPPS}" )

  #This has been added in order to generate files before make -j<N>
  # make -j<N> causes corruption of generated files because of overwriting
  ADD_CUSTOM_TARGET( idl DEPENDS ${CPPS} ${HPPS} COMMENT "Generating sources from .idl files")

  #MESSAGE("CPPS: $ENV{GLOBAL_GENERATED_SRCS}")
  MESSAGE("HPPS: ${HPPS}")
  INSTALL_FILES( /include/kdl/bindings/rtt/corba FILES ${HPPS})
  #GLOBAL_ADD_SRC( ${CPPS} )
  INCLUDE_DIRECTORIES( ${CMAKE_CURRENT_BINARY_DIR} )

  ADD_LIBRARY(orocos-kdltk-corba-${OROCOS_TARGET} SHARED ${CPPS})
  SET_TARGET_PROPERTIES( orocos-kdltk-corba-${OROCOS_TARGET} PROPERTIES
  COMPILE_FLAGS "${CMAKE_CXX_FLAGS_ADD} ${CMAKE_C_FLAGS_RTT} -D_REENTRANT -DOROCOS_TARGET=${OROCOS_TARGET} ${KDL_CFLAGS}"
  SOVERSION "${KDL_VERSION_MAJOR}.${KDL_VERSION_MINOR}"
  VERSION "${KDL_VERSION}"
  INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib/rtt/${OROCOS_TARGET}/plugins")
  # Is used for building  the library
  TARGET_LINK_LIBRARIES(orocos-kdltk-corba-${OROCOS_TARGET} orocos-rtt-corba-${OROCOS_TARGET} orocos-kdltk-${OROCOS_TARGET} ${CORBA_LIBRARIES})
  CONFIGURE_FILE( orocos-kdltk-corba.pc.in ${CMAKE_CURRENT_BINARY_DIR}/orocos-kdltk-corba-${OROCOS_TARGET}.pc @ONLY)

  INSTALL_TARGETS(/lib/rtt/${OROCOS_TARGET}/plugins orocos-kdltk-corba-${OROCOS_TARGET})
  INSTALL_FILES( /lib/pkgconfig FILES ${CMAKE_CURRENT_BINARY_DIR}/orocos-kdltk-corba-${OROCOS_TARGET}.pc)

ENDIF(ENABLE_CORBA)

=== debian/control ===
Source: orocos-kdl
Priority: extra
Maintainer: Ruben Smits <ruben.smits@mech.kuleuven.be>
Build-Depends: debhelper (>= 5), cmake, pkg-config,libboost-dev,doxygen, liborocos-rtt-common-dev,liborocos-rtt-gnulinux-dev,liborocos-rtt-lxrt-dev,liborocos-rtt-xenomai-dev,liborocos-rtt-corba-common-dev, liborocos-rtt-corba-gnulinux-dev ,liborocos-rtt-corba-lxrt-dev,liborocos-rtt-corba-xenomai-dev ,python-sip4-dev (>=4.4.5),python-sip4,python-support,sip4, tao-idl
Standards-Version: 3.7.2
Section: libs

Package: liborocos-kdl1.0-dev
Section: libdevel
Architecture: any
Depends: liborocos-kdl1.0 (= ${Source-Version})
Provides: liborocos-kdl-dev
Conflicts: liborocos-kdl-dev
Replaces: liborocos-kdl-dev
Description: Kinematics and Dynamics Library development files
 Orocos project to supply RealTime usable kinematics and dynamics code,
 it contains code for rigid body kinematics calculations and
 representations for kinematic structures and their inverse and forward
 kinematic solvers.

Package: liborocos-kdl1.0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}
Description: Kinematics and Dynamics Library runtime
 Orocos project to supply RealTime usable kinematics and dynamics code,
 it contains code for rigid body kinematics calculations and
 representations for kinematic structures and their inverse and forward
 kinematic solvers.

Package: liborocos-kdltk-gnulinux1.0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}
Description: Kinematics and Dynamics Library rtt-gnulinux binding
 Orocos project to supply RealTime usable kinematics and dynamics code,
 it contains code for rigid body kinematics calculations and
 representations for kinematic structures and their inverse and forward
 kinematic solvers.

Package: liborocos-kdltk-corba-gnulinux1.0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}
Description: Kinematics and Dynamics Library rtt-corba-gnulinux binding
 Orocos project to supply RealTime usable kinematics and dynamics code,
 it contains code for rigid body kinematics calculations and
 representations for kinematic structures and their inverse and forward
 kinematic solvers.

Package: liborocos-kdltk-lxrt1.0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}
Description: Kinematics and Dynamics Library rtt-lxrt binding
 Orocos project to supply RealTime usable kinematics and dynamics code,
 it contains code for rigid body kinematics calculations and
 representations for kinematic structures and their inverse and forward
 kinematic solvers.

Package: liborocos-kdltk-corba-lxrt1.0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}
Description: Kinematics and Dynamics Library rtt-corba-lxrt binding
 Orocos project to supply RealTime usable kinematics and dynamics code,
 it contains code for rigid body kinematics calculations and
 representations for kinematic structures and their inverse and forward
 kinematic solvers.

Package: liborocos-kdltk-xenomai1.0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}
Description: Kinematics and Dynamics Library rtt-xenomai binding
 Orocos project to supply RealTime usable kinematics and dynamics code,
 it contains code for rigid body kinematics calculations and
 representations for kinematic structures and their inverse and forward
 kinematic solvers.

Package: liborocos-kdltk-corba-xenomai1.0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}
Description: Kinematics and Dynamics Library rtt-coba-xenomai binding
 Orocos project to supply RealTime usable kinematics and dynamics code,
 it contains code for rigid body kinematics calculations and
 representations for kinematic structures and their inverse and forward
 kinematic solvers.

Package: liborocos-kdltk-common1.0-dev
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, liborocos-rtt-common-dev, liborocos-kdl1.0-dev, liborocos-kdltk-gnulinux1.0 | liborocos-kdltk-lxrt1.0 | liborocos-kdltk-xenomai1.0
Provides: liborocos-kdltk-common-dev
Conflicts: liborocos-kdltk-common-dev
Replaces: liborocos-kdltk-common-dev
Description: orocos-rtt binding development files
 Orocos project to supply RealTime usable kinematics and dynamics code,
 it contains code for rigid body kinematics calculations and
 representations for kinematic structures and their inverse and forward
 kinematic solvers.

Package: liborocos-kdltk-gnulinux1.0-dev
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, liborocos-kdltk-common1.0-dev, liborocos-kdltk-gnulinux1.0
Provides: liborocos-kdltk-gnulinux-dev
Conflicts: liborocos-kdltk-gnulinux-dev
Replaces: liborocos-kdltk-gnulinux-dev
Description: orocos-rtt-gnulinux binding development files
 Orocos project to supply RealTime usable kinematics and dynamics code,
 it contains code for rigid body kinematics calculations and
 representations for kinematic structures and their inverse and forward
 kinematic solvers.

Package: liborocos-kdltk-lxrt1.0-dev
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, liborocos-kdltk-common1.0-dev, liborocos-kdltk-lxrt1.0
Provides: liborocos-kdltk-lxrt-dev
Conflicts: liborocos-kdltk-lxrt-dev
Replaces: liborocos-kdltk-lxrt-dev
Description: orocos-rtt-lxrt binding development files
 Orocos project to supply RealTime usable kinematics and dynamics code,
 it contains code for rigid body kinematics calculations and
 representations for kinematic structures and their inverse and forward
 kinematic solvers.

Package: liborocos-kdltk-xenomai1.0-dev
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, liborocos-kdltk-common1.0-dev, liborocos-kdltk-xenomai1.0
Provides: liborocos-kdltk-xenomai-dev
Conflicts: liborocos-kdltk-xenomai-dev
Replaces: liborocos-kdltk-xenomai-dev
Description: orocos-rtt-xenomai binding development files
 Orocos project to supply RealTime usable kinematics and dynamics code,
 it contains code for rigid body kinematics calculations and
 representations for kinematic structures and their inverse and forward
 kinematic solvers.

Package: liborocos-kdltk-corba-common1.0-dev
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, liborocos-rtt-corba-common-dev, liborocos-kdltk-common1.0-dev, liborocos-kdltk-corba-gnulinux1.0 | liborocos-kdltk-corba-lxrt1.0 | liborocos-kdltk-corba-xenomai1.0
Provides: liborocos-kdltk-corba-common-dev
Conflicts: liborocos-kdltk-corba-common-dev
Replaces: liborocos-kdltk-corba-common-dev
Description: orocos-rtt binding development files
 Orocos project to supply RealTime usable kinematics and dynamics code,
 it contains code for rigid body kinematics calculations and
 representations for kinematic structures and their inverse and forward
 kinematic solvers.

Package: liborocos-kdltk-corba-gnulinux1.0-dev
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, liborocos-rtt-corba-common-dev, liborocos-kdltk-corba-common1.0-dev, liborocos-kdltk-gnulinux1.0-dev, liborocos-kdltk-corba-gnulinux1.0
Provides: liborocos-kdltk-corba-gnulinux-dev
Conflicts: liborocos-kdltk-corba-gnulinux-dev
Replaces: liborocos-kdltk-corba-gnulinux-dev
Description: orocos-rtt-corba-gnulinux binding development files
 Orocos project to supply RealTime usable kinematics and dynamics code,
 it contains code for rigid body kinematics calculations and
 representations for kinematic structures and their inverse and forward
 kinematic solvers.

Package: liborocos-kdltk-corba-lxrt1.0-dev
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, liborocos-rtt-corba-common-dev,liborocos-kdltk-corba-common1.0-dev, liborocos-kdltk-lxrt1.0-dev,liborocos-kdltk-corba-lxrt1.0
Provides: liborocos-kdltk-corba-lxrt-dev
Conflicts: liborocos-kdltk-corba-lxrt-dev
Replaces: liborocos-kdltk-corba-lxrt-dev
Description: orocos-rtt-corba-lxrt binding development files
 Orocos project to supply RealTime usable kinematics and dynamics code,
 it contains code for rigid body kinematics calculations and
 representations for kinematic structures and their inverse and forward
 kinematic solvers.

Package: liborocos-kdltk-corba-xenomai-dev
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, liborocos-rtt-corba-common-dev, liborocos-kdltk-corba-common1.0-dev, liborocos-kdltk-xenomai1.0-dev, liborocos-kdltk-corba-xenomai1.0
Description: orocos-rtt-corba-xenomai binding development files
 Orocos project to supply RealTime usable kinematics and dynamics code,
 it contains code for rigid body kinematics calculations and
 representations for kinematic structures and their inverse and forward
 kinematic solvers.

Package: liborocos-kdl-python1.0
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, python, liborocos-kdl1.0
Description: Kinematics and Dynamics Library python binding
 Orocos project to supply RealTime usable kinematics and dynamics code,
 it contains code for rigid body kinematics calculations and
 representations for kinematic structures and their inverse and forward
 kinematic solvers.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1


# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)


CFLAGS = -Wall -g

ifneq (,$(findstring noopt,$(DEB_BUILD_OPTIONS)))
	CFLAGS += -O0
else
	CFLAGS += -O2
endif

# allow parallel build using recommended approach from 
# http://www.de.debian.org/doc/debian-policy/ch-source.html@s-debianrules-options
#
# For Bash type:
#
# export DEB_BUILD_OPTIONS="parallel=2"
# svn-buildpackage ...
#
ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	NUMJOBS=$(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	MAKE_FLAGS += -j$(NUMJOBS)
endif

# shared library versions, option 1
#version=2.0.5
#major=2
version=`grep orocos-kdl debian/changelog | head -1 | awk '{print substr($$2,2,length($$2)-2)}'`
major=`grep orocos-kdl debian/changelog | head -1 | awk '{print substr($$2,2,3)}'`
# option 2, assuming the library is created as src/.libs/libfoo.so.2.0.5 or so
#version=`ls src/.libs/lib*.so.* | \
# awk '{if (match($$0,/[0-9]+\.[0-9]+\.[0-9]+$$/)) print substr($$0,RSTART)}'`
#major=`ls src/.libs/lib*.so.* | \
# awk '{if (match($$0,/\.so\.[0-9]+$$/)) print substr($$0,RSTART+4)}'`

include debian/rules.targets

configure: configure-stamp $(CONFIGURE_TARGETS)
configure-stamp:
	dh_testdir
	touch configure-stamp


build: build-stamp $(BUILD_TARGETS)
build-stamp: configure-stamp 
	dh_testdir
	touch build-stamp

clean:
	dh_testdir
	dh_testroot
	rm -f build-stamp* 
	rm -f configure-stamp*

# Add here commands to clean up after the build process.
	-rm -rf build*

	dh_clean 

install: build  $(INSTALL_TARGETS)
	dh_testdir
	dh_testroot
	dh_installdirs

# Build architecture-independent files here.
binary-indep: build install
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installchangelogs 
	dh_installdocs
	dh_installexamples
	dh_install --sourcedir=debian/tmp --list-missing
#	dh_installmenu
#	dh_installdebconf	
#	dh_installlogrotate
#	dh_installemacsen
#	dh_installpam
#	dh_installmime
#	dh_installinit
#	dh_installcron
#	dh_installinfo
	dh_installman
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
#	dh_perl
	dh_pysupport
#	dh_pycentral
#	dh_python
	dh_makeshlibs
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install configure
